#!/usr/local/bin/ruby
# $Id: path_bench.rb,v 1.1 2001/12/28 16:18:03 toki Exp $
# -
# wwwsrv's path manipulation benchmark

require 'benchmark'		# -> http://www.notwork.org/~gotoken/ruby/p/benchmark/
require 'wwwsrv/path'

include Benchmark
STDOUT.sync = true

trial = (ARGV.first && ARGV.first.to_i) || 1_000

puts "[WWWsrv::Path.subpath * #{trial}]"
for i in 1..10
  prefix = '/' + ([ 'test' ] * i).join('/')
  path = '/' + ([ 'test' ] * (i + 1)).join('/')
  puts "#{i}. #{prefix}"
  puts(measure{
    trial.times do
      WWWsrv::Path::subpath(prefix, path)
    end
  })
end

puts "[WWWsrv::Path.normalize_path * #{trial}]"
for i in 1..10
  path = '/' + ([ 'test' ] * i).join('/')
  puts "#{i}. #{path}"
  puts(measure{
    trial.times do
      WWWsrv::Path::normalize_path(path)
    end
  })
end
