#!/usr/local/bin/ruby
# $Id: request_bench.rb,v 1.1 2002/04/20 01:00:56 toki Exp $
# -
# wwwsrv's request benchmark

require 'benchmark'		# -> http://www.notwork.org/~gotoken/ruby/p/benchmark/
require 'wwwsrv/request'

include Benchmark
STDOUT.sync = true

trial = (ARGV.first && ARGV.first.to_i) || 1_000

def comma(num)
  num.to_s.reverse.scan(/\d\d?\d?/).join(',').reverse
end

class PseudoInput
  def initialize(src)
    @src = src.dup
  end

  def gets(rs=nil)
    @src.shift
  end

  def self::convCRNF(src)
    src.map!{ |line|
      line.chomp!("\n")
      line.chomp!("\r")
      line.concat("\r\n")
    }
  end
end

puts "[WWWsrv::Request.parse_line * #{comma(trial)}]"
src = [ "GET / HTTP/1.1\r\n" ]
puts(measure{
  trial.times do
    WWWsrv::Request::parse_line(PseudoInput::new(src))
  end
})

request_source = PseudoInput::convCRNF(<<'EOF'.to_a)
GET / HTTP/1.1
Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*
Accept-Language: ja
Accept-Encoding: gzip, deflate
User-Agent: Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0)
Host: localhost:8088
Connection: Keep-Alive

EOF

puts "[WWWsrv::Request#parse * #{comma(trial)}]"
request = WWWsrv::Request::new
puts(measure{
  trial.times do
    request.clear
    request.parse(PseudoInput::new(request_source))
  end
})

puts "[WWWsrv::Request.parse * #{comma(trial)}]"
puts(measure{
  trial.times do
    WWWsrv::Request::parse(PseudoInput::new(request_source))
  end
})
