#!/usr/local/bin/ruby
# $Id: run_fcgi.rb,v 1.2 2002/05/12 04:52:57 toki Exp $
# -
# FastCGI appliation launcher

require 'socket'

def usage
  puts "usage 1: #{File::basename($0)} inet [port] ([hostname]) [FastCGI application]"
  puts "usage 2: #{File::basename($0)} unix [socket path] [FastCGI application]"
end

def fcgi_run_inet(fcgi_app, hostname, port)
  server_socket = TCPserver::open(hostname, port)
  STDIN.reopen(server_socket)
  exec(fcgi_app)
end

def fcgi_run_unix(fcgi_app, socket_path)
  if (File::exist? socket_path) then
    if (File::socket? socket_path) then
      STDERR.puts "warning: unlink preceding socket file: #{socket_path.inspect}"
      File::unlink(socket_path)
    else
      raise "not a socket file: #{socket_path.inspect}"
    end
  end

  server_socket = UNIXserver::open(socket_path)
  STDIN.reopen(server_socket)
  exec(fcgi_app)
end

begin
  conn_type = ARGV.shift or raise 'required connection type of first argument'
  case (conn_type.downcase)
  when 'inet'
    port = ARGV.shift or raise 'required port number of second argument'
    port = port.to_i
    fcgi_app = ARGV.pop or raise 'required FastCGI application of third argument'
    hostname = ARGV.shift || 'localhost'
    fcgi_run_inet(fcgi_app, hostname, port)
  when 'unix'
    socket_path = ARGV.shift or raise 'required UNIX domain socket path of second argument'
    fcgi_app = ARGV.pop or raise 'required FastCGI application of third argument'
    fcgi_run_unix(fcgi_app, socket_path)
  else
    raise "unknown connection type: #{conn_type.inspect}"
  end
rescue
  STDERR.puts "error: #{$!}"
  usage
  exit 1
end
