#!/usr/local/bin/ruby
# $Id: test_fastcgi.rb,v 1.5 2002/07/25 16:35:48 toki Exp $
# -
# Sample of FastCGI application

require 'thread'
require 'fastcgi'
require 'wwwsrv/htmlconv'

print "#{File::basename($0)}(pid: #{$$})\n"

server = FastCGI::FCGI::new
req_count = 0
req_lock = Mutex::new
begin
  10.times do |i|
    # 1 thread can have 1 connection.
    Thread::new{
      begin
	print "start thread #{i + 1}...\n"
	server.each_request do |request|
	  curr_reqs = req_lock.synchronize{ req_count += 1 }
	  out = request.out
	  out << "Content-type: text/html\n\n"
	  out << "<html>"
	  out << "<head><title>FastCGI/Ruby</title></head>"
	  out << "<body>#{curr_reqs} req_count served so far.<br>"
	  out << "<h1>environment variables</h1>"
	  out << "<table><tr><th>name</th><th>value</th></tr>"
	  for name, value in request.env
	    out << "<tr><td>#{WWWsrv::HTMLconv::quoteHTML(name)}</td>"
	    out << "<td>#{WWWsrv::HTMLconv::quoteHTML(value)}</td></tr>"
	  end
	  out << "</table>"
	  out << "<p>Input was...</p>"
	  out << "<pre>" << WWWsrv::HTMLconv::quoteHTML(request.in.read || '') << "</pre>"
	  out << "</body></html>"
	  request.finish
	end
      rescue Exception
	p $!
	raise
      ensure
	print "end thread #{i + 1}.\n"
      end
    }
  end
  for thread in ThreadGroup::Default.list
    thread.join
  end
ensure
  server.close
end
