#!/usr/local/bin/ruby
# $Id: test_fcgi_auth.rb,v 1.2 2002/06/16 15:11:20 toki Exp $
# -
# Sample of FastCGI Authorizer

require 'thread'
require 'fastcgi'

print "#{File::basename($0)}(pid: #{$$})\n"

server = FastCGI::FCGI::new
begin
  10.times do |i|
    Thread::new{
      begin
	print "start thread #{i + 1}...\n"
	server.each_request do |request|
	  out = request.out
	  if (request.env['REMOTE_ADDR'] == '127.0.0.1') then
	    out << "Status: 200 OK\r\n"
	    out << "Variable-X_FCGI_AUTH: true\r\n"
	    out << "\r\n"
	  else
	    out << "Status: 403 Forbidden\r\n"
	    out << "Content-Type: text/plain\r\n"
	    out << "\r\n"
	    out << "This page is allowed to access from localhost.\n"
	  end
	  request.finish
	end
      rescue Exception
	p $!
	raise
      ensure
	print "end thread #{i + 1}.\n"
      end
    }
  end
  for thread in ThreadGroup::Default.list
    thread.join
  end
ensure
  server.close
end
