#!/usr/local/bin/ruby
# $Id: test_xmlrpc.rb,v 1.1 2002/05/11 03:47:46 toki Exp $
# -
# Call XML-RPC functions of `wwwsrv.conf.xmlrpc'

require 'xmlrpc/client'

client = XMLRPC::Client::new('localhost', '/', 8088)

[ [ 'michael.add', 4, 5 ],
  [ 'michael.sub', 4, 3 ],
  [ 'michael.div', 3, 2 ],
  [ 'michael.div', 3, 2.0 ],
  [ 'michael.div', 3, 0 ],
  [ 'system.multicall', [
      { 'methodName' => 'michael.add', 'params' => [ 4, 5 ] },
      { 'methodName' => 'michael.sub', 'params' => [ 4, 3 ] },
      { 'methodName' => 'michael.div', 'params' => [ 3, 2.0 ] }
    ]
  ]
].each do |name, *args|
  print 'call: ', name, '('
  print args.map{ |arg| arg.inspect }.join(', ')
  print ")\n"
  begin
    result = client.call(name, *args)
    print "result: #{result.inspect}\n"
  rescue XMLRPC::FaultException
    print "failure: #{$!}\n"
  end
end

for name in client.call('system.listMethods')
  print 'introspection: ', name, ', '
  print client.call('system.methodSignature', name).inspect, ', '
  print client.call('system.methodHelp', name), "\n"
end
