# $Id: obsolete.rb,v 1.32.2.2 2003/04/11 14:09:05 toki Exp $
# -
# obsolete definitions for wwwsrv's core libraries

=begin
Copyright (c) 2001-2002
	TOKI Yoshinori <toki@freedom.ne.jp>. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  1.  Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.

  2.  Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

  3.  The name of the author may not be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
=end

raise 'required obsolete library although $NOT_COMPAT is true.' if $WWWSRV_NOT_COMPAT

# for wwwsrv/process.rb

require 'wwwsrv/process'

module WWWsrv
  LOCK = PROCESS_LOCK
  ProcessProtect = ProtectProcess
  EnvironmentProtect = ProtectProcess
end

# for wwwsrv/ioutil.rb

require 'wwwsrv/ioutil'

module WWWsrv
  module ProtectConnection
    def protect_connection
      begin
	yield
      rescue IOError, SystemCallError
	raise ConnectionError, $!.inspect, $!.backtrace
      end
    end
    module_function :protect_connection
  end

  ConnectionProtect = ProtectConnection
end

# for wwwsrv/htmlconv.rb

require 'wwwsrv/htmlconv'

module WWWsrv
  module HTMLconv
    def format_date(time)
      http_date(time)
    end
    module_function :format_date
  end
end

# for wwwsrv/path.rb

require 'wwwsrv/path'

module WWWsrv
  module Path
    def split_path(path)
      raise "obsolete module function of `#{type}.split_path'"
    end
    module_function :split_path

    def join_path(path_fragments)
      raise "obsolete module function of `#{type}.join_path'"
    end
    module_function :join_path

    alias reduce_path subpath
    module_function :reduce_path
  end
end

# for wwwsrv/chunk.rb

require 'wwwsrv/chunk'

module WWWsrv
  module ChunkedTransferCoding
    alias each_chunk scan_chunk
    module_function :each_chunk
  end
end

# for wwwsrv/reader.rb

require 'wwwsrv/reader'

module WWWsrv
  module BufferedReadable
    alias flush_buffer flush_read_buffer
  end

  ChunkedReader = ChunkedTransferCodingReader
end

# for wwwsrv/multipart.rb

require 'wwwsrv/multipart'

module WWWsrv
  module Multipart
    alias each_multipart scan_multipart
    module_function :each_multipart
  end
end

# for wwwsrv/header.rb

require 'wwwsrv/header'

module WWWsrv
  class Header
    def split_token(field_name, parse_params=false, qvalue_order=false)
      field_values = fields(field_name)
      unless (field_values.empty?) then
	tokens = field_values.map{ |value| value.split(/\s*,\s*/) }
	tokens.flatten!
	return tokens unless parse_params

	tokens.map!{ |segment|
	  token, *params = segment.split(/\s*;\s*/)
	  params.map!{ |param|
	    param_name, param_value = param.split(/=/, 2)
	    if (param_value && param_value =~ /^".*"$/) then
	      param_value.sub!(/^"/, '')
	      param_value.sub!(/"$/, '')
	    end
	    [ param_name, param_value ]
	  }
	  [ token ] + params
	}
	return tokens unless qvalue_order

	i = 0
	tokens.map!{ |token, *params|
	  i += 1
	  qvalue = 1
	  if (qpair = params.assoc('q')) then
	    qvalue = qpair[1].to_f
	  end
	  [ qvalue, i, token , params ]
	}
	tokens.sort!{ |(qvalue1, order1, token1, params1), (qvalue2, order2, token2, params2)|
	  cmp = qvalue2 <=> qvalue1
	  cmp = order1 <=> order2 if (cmp == 0)
	  cmp
	}
	tokens.map!{ |qvalue, order, token, params| [ token ] + params }

	return tokens
      end

      []
    end

    alias token_list split_token
  end
end

# for wwwsrv/srvopt.rb

require 'wwwsrv/srvopt'

module WWWsrv
  module Accessor
    def method_missing(id, *args)
      case (args.length)
      when 0
	self[id]
      when 1
	self[id.to_s.sub(/=$/, '').intern] = args.shift
      else
	raise 'wrong arguments: ' + args.map{ |arg| arg.inspect }.join(', ')
      end
    end

    def self::wrap(obj)
     obj.extend(self)
    end
  end

  class ServerOption
    include Accessor
    attr_accessor :parser
  end
end

# for wwwsrv/request.rb

require 'wwwsrv/request'

module WWWsrv
  class Request
    alias __wwwsrv_request_internal_initialize initialize
    private :__wwwsrv_request_internal_initialize

    def initialize(*args)
      __wwwsrv_request_internal_initialize(*args)
      @option = Accessor::wrap(@option)
    end

    public :option

    alias reduce_path subpath
    alias param params
    alias content body
    alias content= body=

    def condition(mtime, etag=nil)
      if (@header.if_range) then
	cond_if_range(mtime, etag)
      else
	cond_if(mtime, etag)
      end
    end
  end
end

# for wwwsrv/response.rb

require 'wwwsrv/response'

module WWWsrv
  class Response
    alias __wwwsrv_response_internal_initialize initialize
    private :__wwwsrv_response_internal_initialize

    def initialize(*args)
      __wwwsrv_response_internal_initialize(*args)
      @option = Accessor::wrap(@option)
    end

    public :option

    def local_path
      @option.local_path
    end

    def local_path=(new_path)
      @option.local_path = new_path
    end
  end
end

# for obsolete wwwsrv/parser.rb

require 'wwwsrv/token'
require 'wwwsrv/header'
require 'wwwsrv/multipart'
require 'wwwsrv/form'
require 'wwwsrv/chunk'
require 'wwwsrv/version'
require 'wwwsrv/request'
require 'wwwsrv/response'

module WWWsrv
  module Parser
    include Token
    module_function :fetch_token
    module_function :fetch_quoted
    module_function :fetch_comment
    module_function :quote_token

    include ChunkedTransferCoding
    module_function :parse_chunk
    module_function :each_chunk

    def parse_header(input, *args)
      Header::parse(input, *args)
    end
    module_function :parse_header

    # include Multipart
    # module_function :each_multipart
    # module_function :parse_multipart

    # include FormData
    # module_function :parse_query
    # module_function :parse_form_data

    def parse_http_version(description)
      HTTPversion::parse(description)
    end
    module_function :parse_http_version

    def parse_request_line(input)
      Request::parse_line(input)
    end
    module_function :parse_request_line

    def parse_request(input)
      Request::parse(input)
    end
    module_function :parse_request

    def parse_status_line(input)
      Response::parse_status_line(input)
    end
    module_function :parse_status_line

    def parse_status_header(field_value)
      Response::parse_status(field_value)
    end
    module_function :parse_status_header
  end
end

# for wwwsrv/document.rb

require 'wwwsrv/document'

module WWWsrv
  module HTTPerror
    def make_error_response(response, status)
      error_response = Response::new(response.version, status)
      error_response.header.server = response.header.server
      error_response
    end
    module_function :make_error_response

    alias ___wwwsrv_http_error_internal_http_error http_error
    private :___wwwsrv_http_error_internal_http_error

    class << self
      alias ___wwwsrv_http_error_internal_http_error http_error
      private :___wwwsrv_http_error_internal_http_error
    end

    def http_error(status, message=nil, header={}, version=HTTP_1_1)
      header_with_version = header.dup
      header_with_version[X_HTTP_VERSION] = version
      ___wwwsrv_http_error_internal_http_error(status, message, header_with_version)
    end
    module_function :http_error
  end

  class << Document
    def http_date(time)
      HTMLconv::http_date(time)
    end

    alias format_date http_date

    def quoteHTML(string)
      HTMLconv::quoteHTML(string)
    end

    def unquoteHTML(string)
      HTMLconv::unquoteHTML(string)
    end

    def quoteSHELL(string)
      HTMLconv::quoteSHELL(string)
    end

    def encodeURL(string)
      HTMLconv::encodeURL(string)
    end

    def decodeURL(string)
      HTMLconv::decodeURL(string)
    end
  end

  class Document
    alias __wwwsrv_document_internal_warm_up warm_up
    private :__wwwsrv_document_internal_warm_up

    def warm_up(log)
      __wwwsrv_document_internal_warm_up(log)
      if (respond_to? :init) then
	log.warning("warning: #{type}\##init method is obsolete!")
	init(log)
      end

      nil
    end

    alias __wwwsrv_document_internal_cool_down cool_down
    private :__wwwsrv_document_internal_cool_down

    def cool_down(log)
      __wwwsrv_document_internal_cool_down(log)
      if (respond_to? :final) then
	log.warning("warning: #{type}\##final method is obsolete!")
	final(log)
      end

      nil
    end

    def respond(srv_opt, prefix, request, response)
      if (self.respond_to? :content) then
	srv_opt.doc_log_warning(self, 'warning: ' +
				'WWWsrv::Document#content method is obsolete and ' +
				'WWWsrv::Document#respond method should be used!')
	content(srv_opt.sid, srv_opt, prefix, request, response) do |arg, *opts|
	  yield(arg, opts)
	end
      elsif (self.respond_to? :session) then
	srv_opt.doc_log_warning(self, 'warning: ' +
				'WWWsrv::Document#session method is obsolete and ' +
				'WWWsrv::Document#respond method should be used!')
	session(sid, srv_opt, prefix, request, response) do |arg, *opts|
	  yield(arg, *opts)
	end
      else
	srv_opt.doc_log_debug(self, 'enter')
	http_error(404, "Empty document: #{request.normalized_path}.")
      end

      nil
    end
  end

  class DocumentFolder
    alias __wwwsrv_folder_internal_mount mount
    private :__wwwsrv_folder_internal_mount

    def mount(document, path, options={}, host=:default)
      case (options)
      when Hash
	__wwwsrv_folder_internal_mount(document, path, options)
      when String
	__wwwsrv_folder_internal_mount(document, path, { :host => host, :page => options })
      when Regexp
	__wwwsrv_folder_internal_mount(document, path, { :host => host, :mask => options })
      when NIL
	__wwwsrv_folder_internal_mount(document, path, { :host => host })
      else
	raise 'invalid 3rd argument: ' + options.inspect
      end
    end

    alias __wwwsrv_folder_internal_umount umount
    private :__wwwsrv_folder_internal_umount

    def umount(path, options={}, host=:default)
      case (options)
      when Hash
	__wwwsrv_folder_internal_umount(path, options)
      when String
	__wwwsrv_folder_internal_umount(path, { :host => host, :page => options })
      when Regexp
	__wwwsrv_folder_internal_umount(path, { :host => host, :mask => options })
      when NIL
	__wwwsrv_folder_internal_umount(path, { :host => host })
      else
	raise 'invalid 2nd argument: ' + options.inspect
      end
    end

    alias __wwwsrv_folder_internal_attach attach
    private :__wwwsrv_folder_internal_attach

    def attach(path, options={}, target=nil, host=:default, &block)
      case (options)
      when Hash
	__wwwsrv_folder_internal_attach(path, options, &block)
      when String
	mount_opts = { :host => host, :page => options }
	mount_opts[:target] = target if target
	__wwwsrv_folder_internal_attach(path, mount_opts, &block)
      when Regexp
	mount_opts = { :host => host, :mask => options }
	mount_opts[:target] = target if target
	__wwwsrv_folder_internal_attach(path, mount_opts, &block)
      when NIL
	mount_opts = { :host => host }
	mount_opts[:target] = target if target
	__wwwsrv_folder_internal_attach(path, mount_opts, &block)
      else
	raise 'invalid 2nd argument: ' + options.inspect
      end
    end
  end

  class DocumentModifier
    def modify_message_body(srv_opt, context, body_fragment, opts=nil)
      if (self.respond_to? :modify_content) then
	srv_opt.doc_log_warning(self, 'warning: ' +
				'WWWsrv::DocumentModifier#modify_content method is obsolete and ' +
				'WWWsrv::DocumentModifier#modify_message_body method should be used!')
	modify_content(srv_opt, context, body_fragment, opts=nil) do |body_fragment2, opts2|
	  yield(body_fragment2, opts2)
	end
      else
	yield(body_fragment, opts)
      end

      nil
    end
  end

  DocumentAlias = AliasDocument
  PartialDocument = DocumentPart
end

# for wwwsrv/alert.rb

require 'wwwsrv/alert'

module WWWsrv
  Alarm = AlertDocument
  DebugAlarm = DebugAlertDocument
end

# for wwwsrv/logger.rb

require 'wwwsrv/logger'

module WWWsrv
  class Logger
    RAW      = INTERNAL
    DISCREET = SYSTEM

    alias discreet system
  end

  class RequestWatcher
    alias watch_request watch_request_head
    alias watch_request_content watch_request_body
  end

  class ResponseWatcher
    alias watch_response watch_response_head
    alias watch_response_content watch_response_body
  end

  class MultiRequestWatcher
    alias watch_request watch_request_head
    alias watch_request_content watch_request_body
  end

  class MultiResponseWatcher
    alias watch_response watch_response_head
    alias watch_response_content watch_response_body
  end

  class RequestLogger
    alias header_logging_priority request_header_logging_priority
    alias header_logging_priority= request_header_logging_priority=
    alias content_logging_priority request_body_logging_priority
    alias content_logging_priority= request_body_logging_priority=
    alias trailer_logging_priority request_trailer_logging_priority
    alias trailer_logging_priority= request_trailer_logging_priority=

    alias watch_request watch_request_head
    alias watch_request_content watch_request_body
  end

  class ResponseLogger
    alias header_logging_priority response_header_logging_priority
    alias header_logging_priority= response_header_logging_priority=
    alias content_logging_priority response_body_logging_priority
    alias content_logging_priority= response_body_logging_priority=
    alias trailer_logging_priority trailer_logging_priority
    alias trailer_logging_priority= trailer_logging_priority=

    alias watch_response watch_response_head
    alias watch_response_content watch_response_body
  end

  RequestPeeker = RequestLogger
  ResponsePeeker = ResponseLogger
end

# for wwwsrv/server.rb

require 'wwwsrv/server'

module WWWsrv
  class Server
    MAX_CONNECTIONS = WWWsrv::MAX_CONNECTIONS
    TIMEOUT = WWWsrv::TIMEOUT
    KEEP_ALIVE = WWWsrv::KEEP_ALIVE
    BUFFER_SIZE = WWWsrv::BUFFER_SIZE
    FLUSH_INTERVAL = WWWsrv::BUFFER_SIZE

    alias alarm alert
    alias alarm= alert=
    alias request_peeker request_logger
    alias response_peeker response_logger

    alias __wwwsrv_server_internal_make_server_option make_server_option
    private :__wwwsrv_server_internal_make_server_option

    def make_server_option(sid)
      srv_opt = __wwwsrv_server_internal_make_server_option(sid)
      srv_opt.parser = Parser
      srv_opt
    end
  end
end
