# $Id: xmlrpc.rb,v 1.8 2002/11/22 08:24:54 toki Exp $
# -
# XML-RPC server for wwwsrv

=begin
Copyright (c) 2001-2002
	TOKI Yoshinori <toki@freedom.ne.jp>. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  1.  Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.

  2.  Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

  3.  The name of the author may not be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
=end

require 'xmlrpc/server'
require 'wwwsrv/const'
require 'wwwsrv/delegate'
require 'wwwsrv/document'

module WWWsrv
  class XMLRPCServer < Document
    include Delegatable

    def initialize(server=XMLRPC::BasicServer::new)
      @xmlrpc_server = server
    end

    attr_reader :xmlrpc_server

    def respond(srv_opt, prefix, request, response)
      srv_opt.doc_log_debug(self, 'enter')
      if (request.method == HTTP_POST) then
	xmlrpc_call = request.body.read or http_error(400)
	(xmlrpc_call.length <= 0) and http_error(411)
	xmlrpc_result = @xmlrpc_server.process(xmlrpc_call)
	response.status = 200
	response.header.content_type = 'text/xml'
	response.header.content_length = xmlrpc_result.length.to_s
	yield(response)
	yield(xmlrpc_result)
      else
	http_error(405, "Not allowed request method: #{request.method}.", 'Allow' => 'POST')
      end

      nil
    end

    delegate(XMLRPC::BasicServer, :xmlrpc_server)
  end
end
